package kr.ac.kaist.pomdp.symbolic.hsvi.ippc2011;

import java.io.Serializable;

import kr.ac.kaist.pomdp.symbolic.perseus.DD;

/**
 * BoundPair class used for upper bounds in HSVI
 * 
 * @author Kanghoon Lee (khlee@ai.kaist.ac.kr)
 * @version 2011.06.26
 * 
 */
public class BoundPair implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4800967439673636144L;

	public DD[] b;;
	public double V;
	public boolean dirty;
	public double projectedV; // projected value on simplex cornerPts
	public int numBackupsCreation;

	/**
	 * BoundPair constructor
	 * 
	 * @param b
	 * @param V
	 */
	public BoundPair(DD[] b, double V) {
		this.b = b;
		this.V = V;
		dirty = false;
		projectedV = Double.POSITIVE_INFINITY;
	}

	public String toString() {
		String str = new String("");
		String result = new String("");
		for (int i = 0; i < b.length; i++) {
			b[i].display(str);
			result += str;
		}
		result += "\nvalue: " + V;
		return result;
	}
}
