package kr.ac.kaist.pomdp.symbolic.hsvi.ippc2011;

import kr.ac.kaist.pomdp.symbolic.perseus.DD;

/**
 * Common class
 * 
 * @author Kanghoon Lee (khlee@ai.kaist.ac.kr)
 * @version 2011.06.26
 * 
 */
public class Common {

	public static DD[] DoubleArray = new DD[2];
	public static DD[] TripleArray = new DD[3];

	public static DD[] twoDD(DD a, DD b) {
		DoubleArray[0] = a;
		DoubleArray[1] = b;
		return DoubleArray;
	}

	public static DD[] threeDD(DD a, DD b, DD c) {
		TripleArray[0] = a;
		TripleArray[1] = b;
		TripleArray[2] = c;
		return TripleArray;
	}

	public static DD[] convert2array(java.util.Vector list) {
		DD[] result = new DD[list.size()];
		for (int i = 0; i < list.size(); i++) {
			result[i] = (DD) list.get(i);
		}
		return result;
	}

	public static void addList(java.util.Vector list, DD elm) {
		list.add(elm);
	}

	public static void addList(java.util.Vector list, DD[] elm) {
		for (int i = 0; i < elm.length; i++)
			list.add(elm[i]);
	}

	public static double div(DD dd1, DD dd2) {

		double result = Double.POSITIVE_INFINITY;

		// dd1 precedes dd2
		if (dd1.getVar() > dd2.getVar()) {
			for (int i = 0; i < dd1.getChildren().length; i++) {
				result = Math.min(result, div(dd1.getChildren()[i], dd2));
			}

			return result;
		}

		// dd2 precedes dd1 {
		else if (dd2.getVar() > dd1.getVar()) {
			for (int i = 0; i < dd2.getChildren().length; i++) {
				result = Math.min(result, div(dd1, dd2.getChildren()[i]));
			}
			return result;
		}

		// dd2 and dd1 have same root var
		else if (dd1.getVar() > 0) {

			for (int i = 0; i < dd1.getChildren().length; i++) {
				result = Math.min(result,
						div(dd1.getChildren()[i], dd2.getChildren()[i]));
			}
			return result;
		}

		// dd1 and dd2 are leaves
		else {
			if (dd2.getVal() == 0)
				return Double.POSITIVE_INFINITY;
			double newVal = dd1.getVal() / dd2.getVal();

			return newVal;
		}
	}

	public static int getObsId(int[] config, int[] arity) {
		int result = 0;
		for (int i = 0; i < config.length; i++) {
			int mult = 1;
			for (int j = 0; j < i; j++) {
				mult *= arity[j];
			}
			result += mult * (config[i] - 1);
		}
		return result;
	}

	public static int getMult(int[] config, int[] arity) {
		int mult = 1;
		for (int i = 0; i < config.length; i++) {
			if (config[i] == 0)
				mult *= arity[i];
		}
		return mult;
	}

	public static boolean isSameConfig(int[] target, int[] orig) {
		for (int i = 0; i < target.length; i++) {
			if (target[i] == 0)
				continue;
			if (target[i] != orig[i])
				return false;
		}
		return true;
	}
}
