package kr.ac.kaist.pomdp.symbolic.hsvi.ippc2011;

import java.io.Serializable;

/**
 * Edge class used in POMDP tree structure
 * 
 * @author Kanghoon Lee (khlee@ai.kaist.ac.kr)
 * @version 2011.06.26
 * 
 */
public class Edge implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 660337987253949836L;

	public static Edge zeroEdge = zeroEdge();

	public int[] obsConfig;
	public double obsProb;
	public Node nextNode;
	public int mult;

	public int[][] invPerm;

	public static Edge zeroEdge() {
		Edge e = new Edge();
		e.obsProb = 0;
		return e;
	}

	public int hashCode() {
		if (obsConfig == null)
			return -1;

		int sum = 0;
		for (int i = 0; i < obsConfig.length; i++) {
			sum += obsConfig[i];
		}
		return sum;
	}

	// public boolean equals(Object o)
	// {
	// int[] key1 = this.obsConfig;
	// int[] key2 = ((Edge) o).obsConfig;
	//
	// for (int i = 0; i < key1.length; i++)
	// {
	// if (key1[i] != key2[i])
	// return false;
	// }
	// return true;
	// }

	public boolean equals(Object o) {
		if (obsProb == 0) {
			if (((Edge) o).obsProb == 0)
				return true;
			else
				return false;
		}

		return nextNode.equals(((Edge) o).nextNode);
	}
}
