package kr.ac.kaist.pomdp.symbolic.hsvi.ippc2011;

import java.io.PrintStream;
import java.io.Serializable;

/**
 * abstact class DD whose leaves are belief
 * 
 * @author Kanghoon Lee (khlee@ai.kaist.ac.kr)
 * @version 2011.06.26
 * 
 */
public abstract class EdgeDd implements Serializable {
	private static final long serialVersionUID = 2831588294942645927L;

	// predefined static variable one and zero
	public static EdgeDd zero = EdgeDdLeaf.myNew(Edge.zeroEdge);

	protected int var;

	public int getVar() {
		return var;
	}

	public int getAddress() {
		return super.hashCode();
	}

	public EdgeDd[] getChildren() {
		return null;
	} // should throw exception

	public Edge getEdge() {
		return null;
	} // should throw exception

	public int[][] getConfig() {
		return null;
	} // should throw exception

	public void display() {
		if (getNumLeaves() > 10000)
			System.out
					.println("Cannot display trees with more than 10,000 leaves (this tree has "
							+ getNumLeaves() + " leaves)");
		else {
			display("");
			System.out.println();
		}
	}

	abstract public void display(String space);

	abstract public void display(String space, String prefix);

	abstract public void printSpuddDD(PrintStream ps);

	abstract public int getNumLeaves();

	abstract public int[] getVarSet();

	abstract public EdgeDd store();

	public static EdgeDd cast(EdgeDdLeaf leaf) {
		return (EdgeDd) leaf;
	}

	public static EdgeDd cast(EdgeDdNode node) {
		return (EdgeDd) node;
	}
}
